#include <stdlib.h>
#include <iosfwd>
#include <algorithm>
#include <assert.h>
#include <boost/config.hpp>
#include <boost/utility.hpp>
#ifndef BOOST_NO_SLIST
#  include <slist> // shouldn't have to include this... -JGS
#endif
#include <boost/graph/graph_traits.hpp>
#include <boost/graph/properties.hpp>
#include <boost/pending/container_traits.hpp>
#include <boost/graph/depth_first_search.hpp>
#include <boost/random/mersenne_twister.hpp>
#include <boost/random/uniform_int.hpp>

namespace boost {

  template <typename MutableGraph, class Uniform_01_RandNumGen>
  void generate_random_acyclic_graph
  (MutableGraph& g,
   typename graph_traits<MutableGraph>::vertices_size_type V,
   double edge_probability,
   Uniform_01_RandNumGen& gen)
  {
    typedef graph_traits<MutableGraph> Traits;
    typedef typename Traits::vertices_size_type v_size_t;
    typedef typename Traits::edges_size_type e_size_t;
    typedef typename Traits::vertex_descriptor vertex_descriptor;

    for (v_size_t i = 0; i < V; ++i)
      add_vertex(g);

    for (v_size_t i = 0; i < V; ++i)
      for (v_size_t j = i+1; j < V; ++j) 
	if (gen() < edge_probability)
	  add_edge(i, j, g);
  }

} // namespace boost
